//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "TInterfaces_Editor.h"
#include "TDebuggingForm.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TInterfaces_Editor *Interfaces_Editor;
//---------------------------------------------------------------------------
__fastcall TInterfaces_Editor::TInterfaces_Editor(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
bool    __fastcall  TInterfaces_Editor::IsThisAndThat( TStringList* known_items, AnsiString string, AnsiString* this_string, AnsiString* that_string )
{
int and_pos = string.Pos(" and ");
if (and_pos==0) return false;
*this_string = string.SubString(1,and_pos-1);
Dbg("inside IsThisAndThat():: this_string == '" + *this_string + "'" );
*that_string = string.SubString( and_pos+5, ImportString.Length() - and_pos+1 );
Dbg("inside IsThisAndThat():: that_string == '" + *that_string + "'" );
return (IsPropertyName(known_items,*this_string) && IsPropertyName(known_items,*that_string));
}
//---------------------------------------------------------------------------
bool    __fastcall  TInterfaces_Editor::IsThisAndThatAndSomethingElse( TStringList* known_items, AnsiString string, TStringList* result_strings )
{
result_strings->Clear();
//Dbg("inside IsThisAndThatAndSomethingElse():: before checking for comma, string == '" + string + "'" );
int comma_pos = string.Pos(",");
while (comma_pos!=0)
    {
    result_strings->Add( string.SubString(1,comma_pos-1) );
//Dbg("inside IsThisAndThatAndSomethingElse():: found a comma... added substring == '" + string.SubString(1,comma_pos-1) + "'" );
    string.Delete(1,comma_pos+1);
//    Dbg("inside IsThisAndThatAndSomethingElse():: after deletion, string == '" + string + "'" );
//Dbg("inside IsThisAndThatAndSomethingElse():: before checking for comma, string == '" + string + "'" );
    comma_pos = string.Pos(",");
    }
//Dbg("inside IsThisAndThatAndSomethingElse():: string == '" + string + "'" );
//Dbg("inside IsThisAndThatAndSomethingElse():: checking for 'and'" );
int and_pos = string.Pos("and ");
if (and_pos!=0)
    {
//    Dbg("inside IsThisAndThatAndSomethingElse():: found an 'and'... adding substring '" + string.SubString(and_pos+4,string.Length() - (and_pos+3)) + "'" );
    result_strings->Add( string.SubString(and_pos+4,string.Length() - (and_pos+3)) );
    }
bool result = false;
for (int i=0;i<result_strings->Count;i++) result |= IsPropertyName(known_items,result_strings->Strings[i]);
return result;
}
//---------------------------------------------------------------------------
void    __fastcall  TInterfaces_Editor::FSetImportRow( int row )
{
if (row<ImportStrings->Count) Dbg( "Row #" + IntToStr(row) + ": '" + ImportStrings->Strings[row] + "'" );
fImportRow = row;
}
//---------------------------------------------------------------------------
bool    __fastcall  TInterfaces_Editor::IsPropertyName( TStringList* property_name_strings, AnsiString property_name )
{
for (int i=0;i<property_name_strings->Count;i++) if (property_name_strings->Strings[i]==property_name) return true;
return false;
}

//---------------------------------------------------------------------------
bool    __fastcall  TInterfaces_Editor::IsInterfaceName( TStringList* Interface_name_strings, AnsiString Interface_name )
{
for (int i=0;i<Interface_name_strings->Count;i++) if (Interface_name_strings->Strings[i]==Interface_name) return true;
return false;
}
//---------------------------------------------------------------------------
void __fastcall TInterfaces_Editor::ImportFile( AnsiString pFileName )
{
DebuggingForm->Caption = "Importing DirectX Interfaces.... debugging output";
DebuggingForm->ListBox->Items->Clear();

// load the file into a temporary TStringList
ImportStrings->Clear();

// then copy it to another TStringList so that there are no blank rows
TStringList* temp_ImportStrings = new TStringList();
temp_ImportStrings->LoadFromFile( pFileName );
for (int i=0;i<temp_ImportStrings->Count;i++) if (!temp_ImportStrings->Strings[i].TrimLeft().TrimRight().IsEmpty()) ImportStrings->Add(temp_ImportStrings->Strings[i].TrimLeft().TrimRight());
delete temp_ImportStrings;

Dbg( "Importing file: '" + pFileName + "'.... " );
Msg( "Importing file: '" + pFileName + "'.... " );
ImportRow = 0;

// convert it as required
fInterfaceNames = new TStringList();
fInterfaceDescriptions = new TStringList();
fFunctionNames = new TStringList();
fFunctionDescriptions = new TStringList();
fFunctionReturnValueTypes = new TStringList();
fParameterTypes = new TStringList();
fParameterNames = new TStringList();
fParameterModifiers = new TStringList();   //can be "*" or "FAR *"
fParameterDescriptions = new TStringList();
fFlagNames = new TStringList();
fFlagDescriptions = new TStringList();

// scan through each of the 'strings' in the input file & parse as we go.

// check the file to make sure it contains structures
Dbg( ">>> checking for 'Import File Type' definition (ie. Structures, Interfaces, etc. <<<");
if (IsKeyword(ImportString,"Interfaces"))
    {
    Dbg( "Found the 'Import File Type' keyword...");
    Dbg( "... '" + pFileName + "' may be a 'Interfaces' definition file.... attempting to parse...");
    ImportRow++;
    }
else
    ERROR( "There was no file type definition at the top of the file..." );

// Immediately following the 'Interfaces' keyword is a list of the different
// Interfaces defined inside the file.
// By scanning rows for Interface names we build a list of the various
// Interface that we are going to parse.
// When a Interface name is repeated it signifies that the first Interface
// definition is following
Dbg( ">>> determining the various Interfaces included in this file <<<");
bool found_first_repeated_Interface = false;
do
    {
    // check the current row to see if it contains a unique structure name
    Dbg( "checking row for a unique Interface name" );
    if (IsInterfaceName(fInterfaceNames, ImportString))
        {
        Dbg( "found a repetition of a Interface name: '" + ImportString + "'... assuming the relevant structure list is finished." );
        found_first_repeated_Interface = true;
        break;  // continue at end of this for loop
        }
    // if we didn't find a unique Interface name
    if (!found_first_repeated_Interface)
        {
        // check that the row conforms to the structure naming rules
        if (IsValidInterfaceName(ImportString))
            {
            Dbg( "found a valid Interface name: '" + ImportString + "'... adding to internal structures list" );
            fInterfaceNames->Add( ImportString );
            ImportRow++;
            if (ImportRow == ImportStrings->Count) ERROR( "scanned all rows but did not find a Interface name repeated after the 'Interface included in this file' block...");
            }
        else ERROR( "scanned all rows but did not find a Interface name repeated after the 'Structures included in this file' block...");
        }
    }

while (!found_first_repeated_Interface);

// since we now know how many interfaces we need to parse, attempt to parse that many interfaces
for (int interface_index=0;interface_index<fInterfaceNames->Count;interface_index++)
    {
    Dbg( ">>> parsing Interface definition #" + IntToStr(interface_index) + " <<<" );

    // clear internal storage
    //TStringList* TempFunctionNames = new TStringList();
	//TStringList* TempFunctionDescriptions = new TStringList();
	//TStringList* TempFunctionReturnValueTypes = new TStringList();
	TStringList* TempParameterTypes = new TStringList();
	TStringList* TempParameterModifiers = new TStringList();
	TStringList* TempParameterNames = new TStringList();
	TStringList* TempParameterDescriptions = new TStringList();
    TStringList* TempFlagNames = new TStringList();
	TStringList* TempFlagDescriptions = new TStringList();
	// since we already know the names, check that the definition is appropriate but otherwise
    // ignore this row.
    Dbg( "Checking Interface name to make sure that a definition is following");
    if (ImportString!=fInterfaceNames->Strings[interface_index]) ERROR( "Did not find the expected Interface name: '" + fInterfaceNames->Strings[interface_index] + "'" );
    Dbg( "name is valid for Interface: '" + fInterfaceNames->Strings[interface_index] + "'..." );
    Dbg( "... Assuming that a Interface definition for '" + fInterfaceNames->Strings[interface_index] + "' is following" );
    Msg( "Parsing Interface: '" + fInterfaceNames->Strings[interface_index] + "'" );
    ImportRow++;

    // simply add the Interface description
    Dbg( "Assuming row #" + IntToStr( ImportRow ) + " is a description for Interface: '" + fInterfaceNames->Strings[interface_index] + "'" );
    fInterfaceDescriptions->Add( ImportString );
    ImportRow++;



    // read in the properties
    Dbg( "checking row for a property token..." );
    if (!IsSingleToken(ImportString)) ERROR( "property list not found for '" + fInterfaceNames->Strings[interface_index] + "'" );
    Dbg( "... property list found ..." );
    fFunctionNames->Add( ImportString );
    ImportRow++;

    // the following rows may occur anywhere.... hence we loop till we find the end of the 'struct' definition
    bool end_of_functions = false;
    Dbg( "parsing functions..." );
    do
        {
        // skip out when we find the end-token
        if (!IsSingleToken(ImportString))
            {
            Dbg( "Found the end of the functions list." );
            end_of_functions = true;
            continue;
            }
   		fFunctionNames->Add( ImportString );
        ImportRow++;
        }
    while (!end_of_functions);


    // we now process the function descriptions and their parameters.
    for (int interface_index=0;interface_index<fInterfaceNames->Count;interface_index++)
    	// "IDirect3DRMArray::GetSize"
 	   	Dbg( "expecting a '::' keyword... comparing..." );
	    if (ImportString.Pos("::")==0) ERROR( "Did not find the '::' keyword as expected." );
 	   	Dbg( "row contained a valid '::' keyword" );
 	   	ImportRow++;
		// now we have a description for the Function
		if (IsSingleToken(ImportString))
        	{
        	//error, not a description
        	ERROR( "Did not find Function Description as expected." );
		   	//ImportRow++;
        	}
    	else
    		{
       	 	fFunctionDescriptions->Add( ImportString );
 	   		ImportRow++;
       		}
        // next ... is DWORD GetSize( );
        // we get the "DWORD" as FunctionReturnType
        do
        	{
        	if (ImportString.Pos(");") == 0) continue;
     	   	ImportRow++;
			//LPDIRECT3DRMDEVICE lplpD3DRMDevice,
			//LPDIRECT3DRMDEVICE *lplpD3DRMDevice,
			//LPDIRECT3DRMDEVICE * lplpD3DRMDevice,
			//LPDIRECT3DRMDEVICE FAR *lplpD3DRMDevice,
			//LPDIRECT3DRMDEVICE FAR * lplpD3DRMDevice

	        if (ImportString.Pos("*") != 0)
            	// found "*", ParameterName is ltrim of the rest of the substring
                // this takes the FAR into account when we create the parameter modifyer
                // which can be "*" or "FAR *"

            	{
                int x = ImportString.Pos("*");
                int y = ImportString.Pos(",");
                int z = ImportString.Pos(" ");
                int w = ImportString.Length();
                if (y>0)
                	y = w - x - 1 ;//chop off the ","
                else
                    y = w - x;
                fParameterNames->Add(ImportString.SubString(x,y));
                fParameterModifiers->Add(ImportString.SubString(z,x-z));
                fParameterTypes->Add(ImportString.SubString(1,z));
    			Dbg( "adding type,modifier,and name"+ImportString );
                }
            else
            	{
                int y = ImportString.Pos(",");
                int z = ImportString.Pos(" ");
                int w = ImportString.Length();
                if (y>0)
                	y = w - z - 1 ;//chop off the ","
                else
                    y = w - z;
                fParameterNames->Add(ImportString.SubString(z,y)); //some trimming required
                fParameterTypes->Add(ImportString.SubString(1,z));
    			Dbg( "adding type, and name"+ImportString );
                }
            }
            //brian here last nite
        while (ImportString.Pos(");") == 0);
    	// we can now parse the descriptions of the various parameters of the interface.
    	// note that some parameters also contain descriptions of various flags.
    	// note also that other parameters contain "something and somethingelse" which
    	// we need to distinguish between.
    	Dbg( "attempting to parse the descriptions for the various interface parameters" );
    	bool checking_last_parameter_flags = false;
    	for (int parameter_index=0;parameter_index<TempParameterNames->Count;parameter_index++)
    	    {
    	    Dbg( "parsing interface parameter  #" + IntToStr(parameter_index) );
    	    // check for the premature end of the members descriptions
    	    if (IsKeyword(ImportString,"QuickInfo"))
    	        {
    	        // special case: if we're checking for flags for the last member, and the check failed
    	        // do not check for "this and that" rules.
    	        if (!checking_last_parameter_flags) ERROR( "found a 'QuickInfo' section before all parameter descriptions were defined." );
    	        Dbg( "found a 'QuickInfo' section after checking all parameter descriptions. Assuming parameter descriptions are completed" );
    	        break;
    	        }
    	    if (IsKeyword(ImportString,"Remarks"))
    	        {
    	        // special case: if we're checking for flags for the last member, and the check failed
    	        // do not check for "this and that" rules.
    	        if (!checking_last_parameter_flags) ERROR( "found a 'Remarks' section before all parameter descriptions were defined." );
    	        Dbg( "found a 'Remarks' section after checking all parameter descriptions. Assuming parameter descriptions are completed" );
    	        break;
    	        }

    	    // if the current line contains the name of the appropriate member, ignore the member name &
    	    // store the description that follows immediately after this row.
    	    Dbg( "expecting parameter name: '" + TempParameterNames->Strings[parameter_index] + "'... checking to make sure that row is a valid parameter name" );
    	    if (ImportString==TempParameterNames->Strings[parameter_index])
    	        {
    	        Dbg( "found a valid parameter name: '" + TempParameterNames->Strings[parameter_index] + "'" );
    	        Msg( "Parsing Interface Parameter: '" + fInterfaceNames->Strings[interface_index] + "::" + TempParameterNames->Strings[parameter_index] + "'" );
    	        ImportRow++;

       	     	Dbg( "assuming row #" + IntToStr(ImportRow) + " as the description for parameter: '" + TempParameterNames->Strings[parameter_index] + "'" );
    	        TempParameterDescriptions->Add( EncodeValue("InterfaceIndex",interface_index) + ImportString );
    	        ImportRow++;

    	        // check if there are any flags following the member description
   	         	Dbg( "checking to see if flags are declared following the parameter description" );
   	         if (IsFlag(ImportString))
                {
                Dbg( "found a flag rule immdediately following the parameter description." );
                do
                    {
                    Dbg( "adding a parameter flag: '" + ImportString + "'" );
                    Msg( "Found Interface Parameter Flag: '" + fParameterNames->Strings[parameter_index] + "::" + TempParameterNames->Strings[parameter_index] + "'" + "::" + ImportString );
                    TempFlagNames->Add( ImportString);
                    // check for flag descriptions declared on the same line as the flag name
                    int temp_pos = ImportString.Pos(" ");
                    if (temp_pos!=0)
                        {
                        Dbg( "the parameter flag row also contains the relevant flag description" );
                        AnsiString flag_description = ImportString.SubString(temp_pos,ImportString.Length()-temp_pos).TrimLeft();
                        Dbg( "adding the parameter flag description: '" + flag_description + "'" );
                        TempFlagDescriptions->Add(EncodeValue("FlagInterfaceIndex",interface_index) + EncodeValue("FlagParameterIndex",parameter_index) + flag_description);
                        }
                    else
                        // check just to make sure that the flags do not have descriptions with them...
                        if (IsFlag(ImportString))
                            {
                            Dbg( "the parameter flag description is assumed to be on the next row..." );
                            ImportRow++;
                            Dbg("adding a parameter flag description: '" + ImportString + "'" );
                            TempFlagDescriptions->Add(EncodeValue("FlagInterfaceIndex",interface_index) + EncodeValue("FlagParameterIndex",parameter_index) + ImportString);
                            ImportRow++;
                            }
                        else
                            ERROR( "a flag was encountered followed immediately by another flag with no descriptions !" );
                    }
                while (IsFlag(ImportString));
                }
            else
                Dbg( "there are no flags following the parameter description" );
            }
        else
            // it's not a simple parameter, where one was expected.... maybe it's a case of "this and that".... or "this, that, and something else"
            {
            Dbg( "did not find a parameter name where expected... checking 'this and that' rules..." );
            // if there is another parameter name following this one....
            if (parameter_index<TempParameterNames->Count-1) // room for this and that
                {
                Dbg( "...checking 'this and that' rules");
                AnsiString first_parameter_name;
                AnsiString second_parameter_name;
                if (IsThisAndThat(TempParameterNames,ImportString,&first_parameter_name,&second_parameter_name))
                    {
                    Dbg( "the row fits the rules for a 'this and that' type description" );
                    ImportRow++;    // skip past the "this and that" row
                    Dbg( "assuming row #" + IntToStr(ImportRow) + " is the description for parameters: '" + first_parameter_name + "' and '" + second_parameter_name + "'" );
                    TempParameterDescriptions->Add( EncodeValue("InterfaceIndex",interface_index) + ImportString );
                    TempParameterDescriptions->Add( EncodeValue("InterfaceIndex",interface_index) + ImportString );
                    ImportRow++;
                    parameter_index++;
                    }
                else
                    {
                    Dbg( "the row did not fit the 'this and that' rule. Checking 'this, that, and something else' rule..." );
                    TStringList* temp_parameter_names = new TStringList();
                    if (IsThisAndThatAndSomethingElse(TempParameterNames,ImportString, temp_parameter_names ))
                        {
                        Dbg( "the row fits the rules for a 'this, and that and something else' type description" );
                        ImportRow++;    // skip past the "this, that and something else" row
                        for (int i=0;i<temp_parameter_names->Count;i++)
                            {
                            Dbg( "adding parameter description for parameter: '" + temp_parameter_names->Strings[i] + "'" );
                            TempParameterDescriptions->Add( EncodeValue("InterfaceIndex",interface_index) + ImportString );
                            }
                        if (temp_parameter_names->Count>0) parameter_index += temp_parameter_names->Count-1;
                        ImportRow++;
                        }
                    else
                        {
                        Dbg( "Found the following parameter names when checking 'this, that, and something else' rule" );
                        for (int i=0;i<temp_parameter_names->Count;i++) Dbg( "parameter #" + IntToStr(i) + "=='" + temp_parameter_names->Strings[i] + "'" );
                        temp_parameter_names->Clear();
                        delete temp_parameter_names;
                        ERROR( "Expected but did not find a particular parameter name & description: '" + fInterfaceNames->Strings[interface_index] + "::" + TempParameterNames->Strings[parameter_index] + "'" );
                        }
                    temp_parameter_names->Clear();
                    delete temp_parameter_names;
                    }
                }
            else
                ERROR( "Expected but did not find a particular parameter name & description: '" + fInterfaceNames->Strings[interface_index] + "::" + TempParameterNames->Strings[parameter_index] + "'" );
            }
        }

    	// we now expect either a "Remarks" or a "QuickInfo" section
    	// check just to make sure
    	// if it is a 'Remarks' section, simply skip it till we find a "QuickInfo" section.

    	if (ImportString=="Remarks")
    	    while (ImportString!="QuickInfo")
    	        {
    	        ImportRow++;
    	        if (ImportRow>=ImportStrings->Count)
    	            {
    	            Dbg( "Could not parse the import file '" + pFileName + "'.\n" +
                               "Found a 'Remarks' section but did not find the 'QuickInfo' section following" +
                                ImportString );
    	            Dbg( "ERROR LINE: " + ImportString );
    	            DebuggingForm->Show();
    	            DebugLabel->Caption = "";
    	            return;
        	        }
        	    }

		//    Dbg( "Checking if the keyword 'QuickInfo' exists.");
		//    Dbg( "string being checked == '" + ImportString + "'" );
    if (ImportString!="QuickInfo")
        {
        Dbg( "Could not parse the import file '" + pFileName + "'.\n" +
                    "Could not find a 'QuickInfo' section" );
        Dbg( "ERROR LINE: " + ImportString );
        DebuggingForm->Show();
        DebugLabel->Caption = "";
        return;
        }

    // skip past the four lines
//    Dbg( "The keyword 'QuickInfo' exists. skipping the 'QuickInfo' block");
    ImportRow += 5;

    // yey. the structure definition has been successfully parsed.
    Dbg( ">>>>>> Definition of structure '" + fInterfaceNames->Strings[interface_index] + "' was completed successfully! <<<<<<" );

    //    Dbg( "Clearing structure internal representations" );
    int i;
    for (i=0;i<TempFlagDescriptions->Count;i++) fFlagDescriptions->Add( TempFlagDescriptions->Strings[i] );
    for (i=0;i<TempFlagNames->Count;i++) fFlagNames->Add( TempFlagNames->Strings[i] );
    for (i=0;i<TempParameterDescriptions->Count;i++) fParameterDescriptions->Add( TempParameterDescriptions->Strings[i] );
    for (i=0;i<TempParameterTypes->Count;i++) fParameterTypes->Add( TempParameterTypes->Strings[i] );
    for (i=0;i<TempParameterModifiers->Count;i++) fParameterModifiers->Add( TempParameterModifiers->Strings[i] );
    for (i=0;i<TempParameterNames->Count;i++) fParameterNames->Add( TempParameterNames->Strings[i] );

    TempFlagDescriptions->Clear();
    TempFlagNames->Clear();
    TempParameterDescriptions->Clear();
    TempParameterTypes->Clear();
    TempParameterNames->Clear();
    TempParameterModifiers->Clear();

    delete TempFlagDescriptions;
    delete TempFlagNames;
    delete TempParameterDescriptions;
    delete TempParameterTypes;
    delete TempParameterNames;
    delete TempParameterModifiers;
    }

Dbg( IntToStr(fInterfaceNames->Count) + " Interfaces were imported SUCCESSFULLY!" );
Msg( IntToStr(fInterfaceNames->Count) + " Interfaces were imported SUCCESSFULLY!" );

}
//---------------------------------------------------------------------------
AnsiString  __fastcall  TInterfaces_Editor::EncodeValue( AnsiString code, int value )
{
// build an encoded string
return "::[" + code + "," + IntToStr(value) + "]::";
}
