//---------------------------------------------------------------------------
#ifndef TInterfaces_EditorH
#define TInterfaces_EditorH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
#ifdef Dbg
    #undef Dbg
#endif
#define Dbg( STR )          {                                                                               \
                            DebuggingForm->ListBox->Items->Add( (STR) );                                    \
                            }
//---------------------------------------------------------------------------
#ifdef Msg
    #undef Msg
#endif
#define Msg( STR )          {                                                                               \
                            DebugLabel->Caption = (STR);                                                    \
                            DebugLabel->Refresh();                                                          \
                            }
//---------------------------------------------------------------------------
#ifdef ERROR
    #undef ERROR
#endif
#define ERROR( STR )        {                                                                               \
                            DebuggingForm->ListBox->Items->Add( "Error:");                                  \
                            DebuggingForm->ListBox->Items->Add( (STR) );                                    \
                            DebuggingForm->ListBox->Items->Add( "Error Line: " + ImportString );            \
                            DebuggingForm->Show();                                                          \
                            DebugLabel->Caption = "AN ERROR OCCURRED. Check debug output for details...";   \
                            DebugLabel->Refresh();                                                          \
                            return;                                                                         \
                            }

//---------------------------------------------------------------------------
class TInterfaces_Editor : public TForm
{
__published:	// IDE-managed Components
	TLabel *DebugLabel;
private:	// User declarations
    bool    __fastcall  IsKeyword( AnsiString string, AnsiString keyword ) { return (string==keyword); }
    bool    __fastcall  IsValidInterfaceName( AnsiString string ) { return (string.Pos(" ")==0); }
    bool    __fastcall  IsSingleToken( AnsiString string ) { return (string.Pos(" ")==0); }
    bool    __fastcall  IsFlag( AnsiString string )
                            {
                            // if there is a space, maybe its a flag with a description on the same line
                            int temp_pos = string.Pos(" ");
                            if (temp_pos!=0) string = string.SubString(0,temp_pos-1);
                            return (string.AnsiCompare( UpperCase(string)) == 0);
                            }
	bool    __fastcall  TInterfaces_Editor::IsInterfaceName( TStringList* Interface_name_strings, AnsiString Interface_name );
	void __fastcall TInterfaces_Editor::ImportFile( AnsiString pFileName );
    bool    __fastcall  IsThisAndThat( TStringList* known_items, AnsiString string, AnsiString* this_string, AnsiString* that_string );
    bool    __fastcall  IsThisAndThatAndSomethingElse( TStringList* known_items, AnsiString string, TStringList* result_strings );

    TStringList*    fImportStrings;
    int             fImportRow;

    __property  int                 ImportRow = {read=fImportRow,write=FSetImportRow};
    __property  TStringList*        ImportStrings = {read=fImportStrings,write=fImportStrings};
    __property  AnsiString          ImportString = {read=FGetImportString};

    void        __fastcall  FSetImportRow( int row );
    AnsiString  __fastcall  FGetImportString()
                                {
                                if (ImportRow<ImportStrings->Count) return ImportStrings->Strings[ImportRow];
                                return "";
                                }

   TStringList*    fInterfaceNames;
   TStringList*    fInterfaceDescriptions;
   TStringList*    fFunctionNames;
   TStringList*    fFunctionDescriptions;
   TStringList*    fFunctionReturnValueTypes;
   TStringList*    fParameterTypes;
   TStringList*    fParameterNames;
   TStringList*    fParameterModifiers;  //can be "*" or "FAR *"
   TStringList*    fParameterDescriptions;
   TStringList*    fFlagNames;
   TStringList*    fFlagDescriptions;

   AnsiString  __fastcall  EncodeValue( AnsiString code, int value );
   bool    __fastcall  IsPropertyName( TStringList* property_name_strings, AnsiString property_name );


public:		// User declarations
    __fastcall TInterfaces_Editor(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TInterfaces_Editor *Interfaces_Editor;
//---------------------------------------------------------------------------
#endif
