//---------------------------------------------------------------------------
#ifndef TStructures_EditorH
#define TStructures_EditorH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\DBTables.hpp>
#include <vcl\DB.hpp>
#include <vcl\DBCtrls.hpp>
#include <vcl\Mask.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
#ifdef Dbg
    #undef Dbg
#endif
#define Dbg( STR )          {                                                                               \
                            DebuggingForm->ListBox->Items->Add( (STR) );                                    \
                            }
//---------------------------------------------------------------------------
#ifdef Msg
    #undef Msg
#endif
#define Msg( STR )          {                                                                               \
                            DebugLabel->Caption = (STR);                                                    \
                            DebugLabel->Refresh();                                                          \
                            }
//---------------------------------------------------------------------------
#ifdef ERROR
    #undef ERROR
#endif
#define ERROR( STR )        {                                                                               \
                            DebuggingForm->ListBox->Items->Add( "Error:");                                  \
                            DebuggingForm->ListBox->Items->Add( (STR) );                                    \
                            DebuggingForm->ListBox->Items->Add( "Error Line: " + ImportString );            \
                            DebuggingForm->Show();                                                          \
                            DebugLabel->Caption = "AN ERROR OCCURRED. Check debug output for details...";   \
                            DebugLabel->Refresh();                                                          \
                            return;                                                                         \
                            }
//---------------------------------------------------------------------------
class TStructures_Editor : public TForm
{
__published:	// IDE-managed Components
    TTable *Structures_Table;
    TDatabase *DirectX_To_BCB;
    TDataSource *Structures_DataSource;
    TBitBtn *BitBtn1;
    TBitBtn *BitBtn2;
    TOpenDialog *ImportFileDialog;
    TLabel *Label1;
    TQuery *TempQuery;
    TTable *StructureMembers_Table;
    TGroupBox *GroupBox1;
    TDBEdit *DirectX_StructureName_Edit;
    TDBMemo *DirectX_ObjectDescription_Memo;
    TLabel *Label3;
    TLabel *Label2;
    TLabel *Label4;
    TComboBox *DirectX_ComboBox;
    TGroupBox *GroupBox2;
    TLabel *Label5;
    TLabel *Label6;
    TLabel *Label7;
    TDBEdit *BCB_ObjectName_Edit;
    TDBMemo *BCB_ObjectDescription_Memo;
    TComboBox *BCB_ComboBox;
    TGroupBox *GroupBox3;
    TLabel *Label8;
    TGroupBox *GroupBox4;
    TLabel *Label9;
    TComboBox *DirectX_StructureMember_ComboBox;
    TComboBox *BCB_ObjectProperty_ComboBox;
    TDBEdit *DirectX_MemberName_Edit;
    TLabel *Label10;
    TLabel *Label11;
    TDBMemo *DirectX_MemberDescription_Memo;
    TGroupBox *DirectX_MemberFlags_GroupBox;
    TLabel *Label12;
    TComboBox *DirectX_MemberFlags_ComboBox;
    TDBMemo *DirectX_MemberFlagsDescript_Memo;
    TLabel *Label13;
    TLabel *Label14;
    TDBEdit *BCB_PropertyName_Edit;
    TLabel *Label15;
    TDBMemo *BCB_PropertyDescription_Memo;
    TGroupBox *BCB_ObjectFlags_GroupBox;
    TLabel *Label16;
    TLabel *Label17;
    TComboBox *BCB_PropertyFlags_ComboBox;
    TDBMemo *BCB_PropertyFlagsDescript_Memo;
    TTable *StructureMemberFlags_Table;
    TDataSource *StructureMembers_DataSource;
    TDataSource *StructureMemberFlags_DataSource;
    TLabel *DebugLabel;
    TBitBtn *BitBtn3;
    TDBRadioGroup *DBRadioGroup1;
    TBitBtn *BitBtn4;
    void __fastcall BitBtn1Click(TObject *Sender);
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall FormDeactivate(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall DirectX_ComboBoxChange(TObject *Sender);
    void __fastcall DirectX_StructureMember_ComboBoxChange(TObject *Sender);
    void __fastcall DirectX_MemberFlags_ComboBoxChange(TObject *Sender);
    void __fastcall BitBtn3Click(TObject *Sender);
    void __fastcall BCB_ObjectName_EditExit(TObject *Sender);
    void __fastcall BCB_PropertyName_EditExit(TObject *Sender);
    void __fastcall BCB_PropertyFlagsDescript_MemoExit(TObject *Sender);
    void __fastcall DBRadioGroup1Exit(TObject *Sender);

    
    void __fastcall BitBtn4Click(TObject *Sender);
	
protected:
private:	// User declarations
    int     fInterface_Index;
    int     fStructure_Index;
    int     fMember_Index;

    AnsiString  __fastcall  RemoveHungarianNotation( AnsiString hungarian_string ); 
    bool    __fastcall  IsKeyword( AnsiString string, AnsiString keyword ) { return (string==keyword); }
    bool    __fastcall  IsValidStructureName( AnsiString string ) { return (string.Pos(" ")==0); }
    bool    __fastcall  IsStartOfStruct( AnsiString string ) { return (string.Pos("struct")!=0); }
    bool    __fastcall  IsEndOfStruct( AnsiString string ) { return (string.Pos("} ")!=0); }
    bool    __fastcall  IsStartOfUnion( AnsiString string ) { return (string.Pos("union")!=0); }
    bool    __fastcall  IsEndOfUnion( AnsiString string ) { return (string.Pos("};")!=0); }
    bool    __fastcall  ContainsStartBracket( AnsiString string ) { return (string.Pos("{")!=0); }

    bool    __fastcall  IsFlag( AnsiString string )
                            {
                            // if there is a space, maybe its a flag with a description on the same line
                            int temp_pos = string.Pos(" ");
                            if (temp_pos!=0) string = string.SubString(0,temp_pos-1);
                            return (string.AnsiCompare( UpperCase(string)) == 0);
                            }
    bool    __fastcall  IsThisAndThat( TStringList* known_items, AnsiString string, AnsiString* this_string, AnsiString* that_string );
    bool    __fastcall  IsThisAndThatAndSomethingElse( TStringList* known_items, AnsiString string, TStringList* result_strings );

    // import
    void        __fastcall  ImportFile( AnsiString pFileName );
    TStringList*    fImportStrings;
    int             fImportRow;
    __property  int                 ImportRow = {read=fImportRow,write=FSetImportRow};
    __property  TStringList*        ImportStrings = {read=fImportStrings,write=fImportStrings};
    __property  AnsiString          ImportString = {read=FGetImportString};
    void        __fastcall  FSetImportRow( int row );
    AnsiString  __fastcall  FGetImportString()
                                {
                                if (ImportRow<ImportStrings->Count) return ImportStrings->Strings[ImportRow];
                                return "";
                                }

    // structures
    void    __fastcall  ImportStructures( TStringList* strings );

    TStringList*    fStructureNames;
    TStringList*    fStructureDescriptions;
    TStringList*    fMemberNames;
    TStringList*    fMemberTypes;
    TStringList*    fMemberDescriptions;
    TStringList*    fFlagNames;
    TStringList*    fFlagDescriptions;

    AnsiString  __fastcall  EncodeValue( AnsiString code, int value );
    int         __fastcall  DecodeValue( AnsiString code, AnsiString encoded_string, AnsiString* decoded_string );

    bool    __fastcall  IsStructureName( TStringList* structure_name_strings, AnsiString structure_name );
    bool    __fastcall  IsMemberName( TStringList* member_name_strings, AnsiString member_name );
    void    __fastcall  ParseStructure();
    void    __fastcall  ParseStructureMembers();
    void    __fastcall  ParseStructureMemberFlags();


    //void    __fastcall  ImportInterfaces( TStringList* strings );

    void __fastcall BuildSelections();
    void __fastcall BuildStructureSelections();
    void __fastcall BuildMemberSelections();
    void __fastcall BuildFlagSelections();

public:		// User declarations
    __fastcall TStructures_Editor(TComponent* Owner);
    virtual __fastcall ~TStructures_Editor();
};
//---------------------------------------------------------------------------
extern TStructures_Editor *Structures_Editor;
//---------------------------------------------------------------------------
#endif



